require_relative 'linked_list'

# calculate the average of the list
def average list
    sum = 0.0
    count = 0
    
    list.each do |i|
    	 sum += i
    	 count += 1
    end
    
    return sum / count
end

# calculate the median of the list
def median list
	l = []
	
	list.each do |i|
		l << i
	end
	
	l.sort
	mid = l.length/2
	
	return l.length.even? ? (l[mid]+l[mid-1])/2.0 : l[mid]
end

# run some basic experiments
num_entries = 1000

l = LinkedList.new

1.upto(num_entries){|i| l.add i }

puts "Average:\t#{average(l)}"
puts "Median:\t\t#{median(l)}"

# clean-up our linked list when we're done
num_entries.times{l.remove}